<template>
  <div>
    <h3>{{ kex }}.{{ table }}</h3>
    <api-data endpoint="/auth/" v-model="userInfo" />
    <!-- TODO: This should be a table -->
    <h5>Metadata</h5>
    <p>
      Kex id: <code>{{ details?.table?.kex?.kex }}</code
      ><br />
      Project/database: <code>{{ details?.table?.kex?.project }}</code
      ><br />
      Table id: <code>{{ details?.table?.table }}</code
      ><br />
      Created: {{ new Date(details?.created).toLocaleString() }}<br />
      Size: {{ details?.size_readable }}<br />
      Rows count: {{ details?.num_rows }}<br />
    </p>
    <!-- TODO: Refactor this into separate component (e.g. StorageObjectMetadata) -->
    <api-data
      :endpoint="`/storage/kex/${kex}/tables/${table}/metadata`"
      v-model="metadata"
    />
    <h5>Friendly name</h5>
    <!-- TODO: Refactor this into separate component (e.g. EditableParagraph) -->
    <p
      class="editable"
      id="editableName"
      @click="
        editName = true;
        focusEditableContent($event);
      "
      :contenteditable="editName"
      @keydown="editing"
    >
      {{ metadata.name || "No name given" }}
    </p>
    <h5>Description</h5>
    <!-- TODO: Render markdown -->
    <p
      class="editable"
      id="editableDescription"
      @click="
        editDescription = true;
        focusEditableContent($event);
      "
      :contenteditable="editDescription"
      @keydown="editing"
      v-html="descriptionHtml"
    />
    <p>
      Updated by <code>{{ metadata.user || "No one" }}</code> on
      <code>{{ metadata.created || "No date" }}</code> using
      <code>{{ metadata.component || "No component" }}</code>
    </p>
    <!-- ^StorageObjectMetadata -->
    <a
      class="btn btn-primary"
      title="Table preview"
      href="#"
      @click.prevent="togglePreview(true)"
      ><i class="fas fa-eye"></i> Table preview</a
    >
    <dropdown-menu
      class="mx-2"
      title="Actions"
      icon="fas fa-rocket"
      color="primary"
    >
      <a
        href="#"
        class="btn btn-success"
        @click.prevent="copyDialogVisible = true"
        ><i class="fas fa-clone"></i> Copy</a
      >
      <a
        href="#"
        class="btn btn-danger mt-1"
        @click.prevent="deleteDialogVisible = true"
        ><i class="fas fa-trash"></i> Delete</a
      >
      <a
        href="#"
        class="btn btn-danger mt-1"
        @click.prevent="truncateDialogVisible = true"
        ><i class="fas fa-eraser"></i> <span>Truncate</span></a
      >
    </dropdown-menu>
    <api-data
      :endpoint="`/storage/kex/${kex}/tables/${table}`"
      v-model="details"
      ref="tableDetailsApiData"
    />
    <h4 style="margin-top: 0.5rem">Schema</h4>
    <table class="table">
      <thead>
        <tr>
          <th>Column</th>
          <th>Type</th>
          <th>Extra</th>
        </tr>
      </thead>
      <tbody>
        <tr v-for="field in details?.fields || []" :key="field.name">
          <td>{{ field.name }}</td>
          <td>
            <code>{{ field.type }}</code>
          </td>
          <td>{{ field.mode }}</td>
        </tr>
      </tbody>
    </table>
    <keep-alive>
      <table-preview
        v-if="previewVisible"
        :table="table"
        :kex="kex"
        :schema="tableSchema"
        @close="togglePreview(false)"
      />
    </keep-alive>
    <modal-dialog
      v-if="copyDialogVisible"
      :title="`Copy table ${table}`"
      :confirm="copyTargetInvalid || tableTargetExists ? null : 'Copy'"
      :processing="tableTargetExists === null"
      static
      @close="copyDialogClosed"
    >
      <api-data :endpoint="`/storage/tree?public=true`" v-model="tree" />
      Select copy destination:
      <div class="input-group">
        <div class="input-group-prepend">
          <dropdown-menu
            color="secondary"
            icon="fas fa-caret-down"
            :caret="false"
            title=""
          >
            <a
              href="#"
              v-for="k in kexes"
              :key="k"
              class="text-start d-block py-2"
              @click.prevent="
                copyTargetKex = k;
                $refs.copyTargetKex.focus();
              "
            >
              {{ k }}
            </a>
          </dropdown-menu>
        </div>
        <input
          type="text"
          class="form-control"
          placeholder="kex"
          ref="copyTargetKex"
          v-model="copyTargetKex"
        />
        <input
          class="form-control"
          type="text"
          v-model="copyTargetTable"
          placeholder="table"
        />
      </div>
      <p class="mt-2">If the kex does not exist, it will be created.</p>
      <p v-if="copyTargetInvalid" class="alert alert-danger">
        Selected copy target is invalid. Only <code>in_</code> and
        <code>out_</code> kexes are allowed and both names of the kex and the
        table must be set.
      </p>
      <p class="alert alert-danger" v-else-if="tableTargetExists">
        Target table
        <code>{{ copyTargetKex }}.{{ copyTargetTable }}</code> already exists.
      </p>
    </modal-dialog>
    <modal-dialog
      v-if="deleteDialogVisible"
      title="Delete table"
      confirm="Delete"
      static
      @close="deleteDialogClosed"
    >
      <div class="alert alert-danger">
        Do you really wish to delete table <code>{{ kex }}.{{ table }}</code
        >? Please note that this action is irreversible, cannot be taken back
        and somebody may go ballistic.
      </div>
    </modal-dialog>
    <modal-dialog
      v-if="truncateDialogVisible"
      title="Truncate table"
      confirm="Truncate"
      static
      @close="truncateDialogClosed"
    >
      Do you really wish to truncate table <code>{{ kex }}.{{ table }}</code
      >? This will <strong>delete all rows in the table</strong> and cannot be
      undone.
    </modal-dialog>
  </div>
</template>

<script>
import TablePreview from "@/components/TablePreview";

export default {
  name: "TableDetails",
  components: { TablePreview },
  activated() {
    // this.$route gets cached on keep-alive component,
    // this is a workaround to "refresh" the url parameter
    this.previewVisible =
      window.location.href.split("/").splice(-1)[0] === "preview";
  },
  data() {
    const previewVisible = this.$route.params.action === "preview";
    this.tableExistsDelayed();
    return {
      details: {},
      editDescription: false,
      editName: false,
      previewVisible,
      copyDialogVisible: false,
      tree: {},
      copyTargetKexValue: "in_manual_snapshot",
      copyTargetTableValue: this.table,
      deleteDialogVisible: false,
      truncateDialogVisible: false,
      tableExistsPollTimeout: null,
      tableTargetExists: null,
      metadata: {},
      userInfo: {},
    };
  },
  inject: [
    "copyTable",
    "deleteTable",
    "toggleProgressSpinner",
    "truncateTable",
    "tableExists",
    "setTableMetadata",
  ],
  methods: {
    togglePreview(show) {
      this.previewVisible = show;
      if (show) {
        this.pushState(
          "storage",
          [this.kex, this.table, "preview"],
          `Storage - Table ${this.table} Preview`
        );
      } else {
        this.pushState(
          "storage",
          [this.kex, this.table],
          `Storage - Table ${this.table}`
        );
      }
    },
    editing(event) {
      // TODO: Refactor this into separate component (e.g. EditableParagraph)
      // Escape -> Cancel
      if (event.keyCode === 27) {
        this.editDescription = false;
        this.editName = false;
        event.preventDefault = true;
      }
      // Shift+Enter -> Save
      if (event.keyCode === 13 && event.shiftKey) {
        this.editDescription = false;
        this.editName = false;
        const updatedMetadata = {
          user: this.userInfo?.email || "unknown",
          name: document.getElementById("editableName").innerText,
          description: document.getElementById("editableDescription").innerText,
          created: new Date(),
          component: "Flow UI",
        };
        this.setTableMetadata(this.kex, this.table, updatedMetadata);
        event.preventDefault = true;
      }
    },
    copyDialogClosed({ value }) {
      this.copyDialogVisible = false;
      if (!value) return;
      this.toggleProgressSpinner(true);
      this.copyTable(
        `${this.kex}.${this.table}`,
        `${this.copyTargetKex}.${this.copyTargetTable}`
      );
    },
    deleteDialogClosed({ value }) {
      this.deleteDialogVisible = false;
      if (!value) return;
      this.toggleProgressSpinner(true);
      this.deleteTable(this.kex, this.table);
    },
    truncateDialogClosed({ value }) {
      this.truncateDialogVisible = false;
      if (!value) return;
      this.toggleProgressSpinner(true);
      this.truncateTable(this.kex, this.table, () => {
        this.$refs.tableDetailsApiData.load();
      });
    },
    tableExistsDelayed() {
      this.tableTargetExists = null;
      if (this.tableExistsPollTimeout !== null)
        clearTimeout(this.tableExistsPollTimeout);
      if (this.copyTargetInvalid) return;
      this.tableExistsPollTimeout = setTimeout(() => {
        this.tableExists(this.copyTargetKex, this.copyTargetTable, (exists) => {
          this.tableTargetExists = exists;
        });
      }, 500);
    },
    focusEditableContent(event) {
      setTimeout(() => {
        event.target.focus();
      }, 0);

      if (event.target.hasChildNodes()) {
        // if the element is not empty
        let s = window.getSelection();
        let r = document.createRange();
        let e =
          event.target.childElementCount > 0
            ? event.target.lastChild
            : event.target;
        r.setStart(e, 1);
        r.setEnd(e, 1);
        s.removeAllRanges();
        s.addRange(r);
      }
    },
  },
  props: {
    kex: String,
    table: String,
  },
  computed: {
    tableSchema: {
      get() {
        return (this.details?.fields || []).map((el) => el.name);
      },
    },
    kexes: {
      get() {
        return ["in_manual_snapshot", ...Object.keys(this.tree)];
      },
    },
    copyTargetUnsafe: {
      get() {
        for (const prefix of ["dm_", "out_"]) {
          if (this.copyTargetKex.startsWith(prefix)) return true;
        }
        return false;
      },
    },
    copyTargetInvalid() {
      return (
        (!this.copyTargetKex.toLowerCase().startsWith("out_") &&
          !this.copyTargetKex.toLowerCase().startsWith("in_")) ||
        this.copyTargetTable.length < 1
      );
    },
    copyTargetKex: {
      get() {
        return this.copyTargetKexValue;
      },
      set(value) {
        this.copyTargetKexValue = value;
        this.tableExistsDelayed();
      },
    },
    copyTargetTable: {
      get() {
        return this.copyTargetTableValue;
      },
      set(value) {
        this.copyTargetTableValue = value;
        this.tableExistsDelayed();
      },
    },
    descriptionHtml() {
      if (!this.metadata.description) return "No description";
      return this.metadata.description.split("\n").join("<br>");
    },
  },
};
</script>

<style lang="scss">
// TODO: Refactor this into separate component
// Move the icon next to the section header, make .editable a container containing title
// and editable body
.editable {
  &::before {
    content: "\f044";
    font-family: "Font Awesome 5 Free";
    font-weight: 900;
    padding-right: 0.5rem;
  }
  margin-bottom: 1rem;

  &[contenteditable="true"] {
    outline: 1px solid grey;

    &::after {
      display: block;
      position: absolute;
      content: "Press escape to cancel editing, shift+enter to save";
      font-size: 0.7rem;
      color: rgba(0, 0, 0, 0.6);
    }
  }
}
</style>
